//*****************************************************************************************************
//  1. t@C
//		ManualEditView.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CManualEditView NX̃Cve[V
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "workscheduler.h"

#include "ManualEditWnd002.h"
#include "ManualEditView.h"
#include "DataManager.h"
#include "ManualEditFrameWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CManualEditView, CScrollView)

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::CManualEditView
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		NXϐ̏A`IuWFNg̍쐬A@킲Ƃ̃Ot̐F̍쐬sB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
CManualEditView::CManualEditView()
{
	// NXϐ̏
	m_bInitialize = FALSE;

	// `IuWFNg쐬
	m_penGraph.CreatePen(PS_SOLID, 2, RGB(0x00, 0x00, 0x00));
	m_penAxis.CreatePen(PS_SOLID, 2, RGB(0, 0, 0));
	m_penTact.CreatePen(PS_SOLID, 2, RGB(0, 0, 0xff));
	m_penTactLimit.CreatePen(PS_DASH, 1, RGB(0xff, 0x77, 0x33));
	m_penSublineBar.CreatePen(PS_DOT, 1, g_pSystem->m_cIniUser.m_rgbSublineBarColor);
	m_penKyotsuKotei.CreatePen(PS_SOLID, 2, g_pSystem->m_cIniUser.m_rgbCommonProcessColor);
	m_penKittingLine.CreatePen(PS_SOLID, 2, g_pSystem->m_cIniUser.m_rgbKittinglineBarColor);
	m_penKittingSubline.CreatePen(PS_DOT, 1, g_pSystem->m_cIniUser.m_rgbKitSublineBarColor);
	m_fontGraph.CreatePointFont(80, g_pConst->m_sDefaultFontName);
	m_fontH.CreateFont(14, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "MS UI Gothic");
	m_fontV.CreateFont(14, 0, 900, 0, FW_BOLD, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "MS UI Gothic");
	m_fontTime.CreateFont(14, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "MS UI Gothic");
	m_brushJido.CreateSolidBrush(g_pSystem->m_cIniUser.m_rgbAutoProcessColor);
	m_brushHanJido.CreateSolidBrush(g_pSystem->m_cIniUser.m_rgbSemiAutoProcessColor);
	m_brushKyotsuJido.CreateSolidBrush(g_pSystem->m_cIniUser.m_rgbCommonAutoProcessColor);
	m_brushKyotsuHanJido.CreateSolidBrush(g_pSystem->m_cIniUser.m_rgbCommonSemiAutoProcessColor);

	// @킲Ƃ̃uV쐬
	for (int i = 0; i < MAX_KISHU; i++)
		m_brushGraph[i].CreateSolidBrush(g_pSystem->m_cIniUser.m_rgbProcessGraphColor[i]);
}


BEGIN_MESSAGE_MAP(CManualEditView, CScrollView)
	//{{AFX_MSG_MAP(CManualEditView)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
	ON_NOTIFY(TTN_NEEDTEXT, 0, OnGetToolTipText)
END_MESSAGE_MAP()

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::OnInitialUpdate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		r[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		c[`bv\LsB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::OnInitialUpdate()
{
	ModifyStyle(0, WS_CLIPSIBLINGS | WS_CLIPCHILDREN);

	CDC *pDC = GetDC();
	m_dcCompatible.CreateCompatibleDC(pDC);
	ReleaseDC(pDC);

	InitializeZahyoData();

	CScrollView::OnInitialUpdate();

	// c[`bv\L
	EnableToolTips(TRUE);

	// c[`bv"&"\ł悤ɂ
	_AFX_THREAD_STATE* pThreadState = AfxGetThreadState();
	CToolTipCtrl* pToolTip = pThreadState->m_pToolTip;
	if (pThreadState->m_pToolTip == NULL) {
		pThreadState->m_pToolTip = new CToolTipCtrl;
		pThreadState->m_pToolTip->Create(GetParentOwner(), TTS_ALWAYSTIP | TTS_NOPREFIX);
	}

	m_bInitialize = TRUE;
}

void CManualEditView::InitializeZahyoData()
{
	CManualEditDocument *pDoc = GetDocument();

	m_aZahyoSubline.RemoveAll();

	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	m_aZahyoSubline.SetSize(nGraphSublineNum);
	for (int i = 0; i < nGraphSublineNum; i++)
		m_aZahyoSubline[i].cSublineInfo.Create(this);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::OnDraw
//----------------------------------------------------------------------------------------------------
//  2. @\
//		`揈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC			[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		`͔hNXōs߂ł͉ȂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::OnDraw(CDC* pDC)
{
}

void CManualEditView::ClearZahyoData()
{
	m_aZahyoGraph.RemoveAll();
	m_aZahyoKittingSubline.RemoveAll();
	m_aZahyoKyotsuKoteiFrame.RemoveAll();
	m_aZahyoSagyosha.RemoveAll();
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::AddZahyoGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OtWǉ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CRect		&rect				[I] lp`̍W
//		SGraphBlock	*pGraphBlock		[I] OtubNf[^
//		CString		&sDispText			[I] lpɕ\eLXg
//		int			nKishuId			[I] @ID
//		int			nSagyoshaId			[I] ƎID
//		int			nKind				[I] OtށiH or vfƌQj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		m_aZahyoGraphɎw肳ꂽWf[^ǉB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::AddZahyoGraph(const CRect &rect, CString &sText, int nKind, int nKishuId)
{
	if (!rect.IsRectEmpty()) {
		SZahyoGraph *pZahyoGraph = m_aZahyoGraph.AddElement();
		pZahyoGraph->rect = rect;
		pZahyoGraph->sText = sText;
		pZahyoGraph->nKind = nKind;
		pZahyoGraph->nKishuId = nKishuId;
	}
}

// ʍHgWǉ
int CManualEditView::AddKyotsuKoteiFrame(const CRect &rect)
{
	int nIndex;
	SZahyoKyotsuKoteiFrame *pZahyoKyotsuKoteiFrame = m_aZahyoKyotsuKoteiFrame.AddElement(nIndex);
	pZahyoKyotsuKoteiFrame->rect = rect;
	return nIndex;
}

void CManualEditView::AddZahyoSagyosha(const CRect &rect, int nSublineId, int nSagyoshaId)
{
	SZahyoSagyosha *pZahyoSagyosha = m_aZahyoSagyosha.AddElement();
	pZahyoSagyosha->rect = rect;
	pZahyoSagyosha->nSublineId = nSublineId;
	pZahyoSagyosha->nSagyoshaId = nSagyoshaId;
}

SZahyoSagyosha *CManualEditView::CheckZahyoSagyosha(CPoint point)
{
	point += GetScrollPosition();

	// Wz̒w肳ꂽʒu܂ގlp`
	int nSize = m_aZahyoSagyosha.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoSagyosha *pZahyoSagyosha = &m_aZahyoSagyosha[i];
		if (pZahyoSagyosha->rect.PtInRect(point))
			return pZahyoSagyosha;
	}

	return NULL;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawGraph
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//		BOOL	bDrawText			[I] lpɃeLXgTRUEF\AFALSEF\Ȃ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		m_aZahyoGraphɐݒ肳ꂽWf[^ɏ]Ďlp`yт̒̃eLXg\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawGraph(CDC *pDC, BOOL bDrawText)
{
	CPen *pPenOrg = pDC->SelectObject(&m_penGraph);
	CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);
	CFont *pFontOrg = pDC->SelectObject(&m_fontGraph);

	// Wz̑SĂ\
	int nSize = m_aZahyoGraph.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoGraph &cZahyoGraph = m_aZahyoGraph[i];
		CRect &rect = cZahyoGraph.rect;

		// lp`\̈`FbN
		CRect rect2(rect.left - 1, rect.top - 1, rect.right + 1, rect.bottom + 1);
		if (pDC->RectVisible(rect2)) {
			switch (cZahyoGraph.nKind) {
			case COORDINATE_KIND_SAGYO:
				if (cZahyoGraph.rect.Height() != 0) {
					// Ot̐FI
					pDC->SelectObject(&m_brushGraph[cZahyoGraph.nKishuId]);

					// eHEvfƌQ̎lp`\
					CRect rect2(rect.left, rect.top, rect.right + 1, rect.bottom + 1);
					pDC->Rectangle(rect2);

					// lp`̒ɍHEvfƌQ\
					if (bDrawText)
						DrawTextCenter(pDC, cZahyoGraph.sText, rect2);
				}
				break;
			case COORDINATE_KIND_JIDO:
				// H̐Op\
				pDC->SelectObject(&m_brushJido);
				DrawLeftTriangle(pDC, rect);
				break;
			case COORDINATE_KIND_HANJIDO:
				// H̉FOp\
				pDC->SelectObject(&m_brushHanJido);
				DrawLeftTriangle(pDC, rect);
				break;
			case COORDINATE_KIND_JIDO_KYOTSU:
				// ʎH̐Op\
				pDC->SelectObject(&m_brushKyotsuJido);
				DrawLeftTriangle(pDC, rect);
				break;
			case COORDINATE_KIND_HANJIDO_KYOTSU:
				// ʔH̉FOp\
				pDC->SelectObject(&m_brushKyotsuHanJido);
				DrawLeftTriangle(pDC, rect);
				break;
			case COORDINATE_KIND_KYOTSU_KOTEI:
				CBitmap *pBitmapOrg = m_dcCompatible.SelectObject(&m_bmpKyotsuKotei);
				pDC->BitBlt(rect.left, rect.top, rect.Width(), rect.Height(), &m_dcCompatible, 0, 0, SRCCOPY);
				m_dcCompatible.SelectObject(pBitmapOrg);
				break;
			}
		}
	}

	pDC->SelectObject(pPenOrg);
	pDC->SelectObject(pBrushOrg);
	pDC->SelectObject(pFontOrg);
}

// ʍHg`
void CManualEditView::DrawKyotsuKoteiFrame(CDC *pDC)
{
	CPen *pPenOrg = pDC->SelectObject(&m_penKyotsuKotei);
	CBrush *pBrushOrg = (CBrush *)pDC->SelectStockObject(NULL_BRUSH);

	int nSize = m_aZahyoKyotsuKoteiFrame.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoKyotsuKoteiFrame &cKyotsuKotei = m_aZahyoKyotsuKoteiFrame[i];

		CRect rect2(cKyotsuKotei.rect.left - 1, cKyotsuKotei.rect.top - 1, cKyotsuKotei.rect.right + 1, cKyotsuKotei.rect.bottom + 1);
		if (pDC->RectVisible(rect2)) {
			CRect rect2(cKyotsuKotei.rect.left, cKyotsuKotei.rect.top, cKyotsuKotei.rect.right + 1, cKyotsuKotei.rect.bottom + 1);
			pDC->Rectangle(rect2);
		}
	}

	pDC->SelectObject(pPenOrg);
	pDC->SelectObject(pBrushOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawLeftTriangle
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Op`\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//		CRect	&rect				[I] Op`\W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽWɍOp`\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawLeftTriangle(CDC *pDC, const CRect &rect)
{
	CPoint point[3];

	point[0].x = rect.left;
	point[0].y = rect.top + rect.Height() / 2;
	point[1].x = rect.right;
	point[1].y = rect.top;
	point[2].x = rect.right;
	point[2].y = rect.bottom;
	CPen *pPen = (CPen *)pDC->SelectStockObject(BLACK_PEN);
	pDC->Polygon(point, 3);
	pDC->SelectObject(pPen);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawRightTriangle
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EOp`\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//		CRect	&rect				[I] Op`\W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽWɉEOp`\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawRightTriangle(CDC *pDC, const CRect &rect)
{
	CPoint point[3];

	point[0].x = rect.right;
	point[0].y = rect.top + rect.Height() / 2;
	point[1].x = rect.left;
	point[1].y = rect.top;
	point[2].x = rect.left;
	point[2].y = rect.bottom;
	CPen *pPen = (CPen *)pDC->SelectStockObject(BLACK_PEN);
	pDC->Polygon(point, 3);
	pDC->SelectObject(pPen);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawTextCenter
//----------------------------------------------------------------------------------------------------
//  2. @\
//		eLXgw肳ꂽg̒ɕ`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//		CString	&sText				[I] \eLXg
//		CRect	&rect				[I] g̎lp`̍W
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽlp`̍W̒ɃeLXg\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawTextCenter(CDC *pDC, const CString &sText, CRect rect)
{
	// g̃}[Wm
	rect.left += 2;
	rect.top += 1;
	rect.right -= 2;
	rect.bottom -= 1;

	CRect rectText(rect);
	CRect rectText2(rectText);

	if (rect.Height() > 20) {
		// `̃TCY擾
		pDC->DrawText(sText, rectText, DT_CENTER | DT_WORDBREAK | DT_CALCRECT | DT_EDITCONTROL | DT_NOPREFIX);

		// ㉺̃Z^Oʒu߂
		CSize sizeOffset((rect.Width() - rectText.Width()) / 2, (rect.Height() - rectText.Height()) / 2);

		if (sizeOffset.cy > 0) {
			// gɓꍇ͂̂܂ܕ\
			rectText.OffsetRect(sizeOffset);
			pDC->DrawText(sText, rectText, DT_CENTER | DT_WORDBREAK | DT_EDITCONTROL | DT_NOPREFIX);
			return;
		}
	}

	// gɓȂꍇ͂PsŏȗLtĕ\
	CString sText2(sText);
	sText2.Replace('\n', ' ');
	pDC->DrawText(sText2, rectText2, DT_CENTER | DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawVerticalAxisLine
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot̏c`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̏c`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawVerticalAxisLine(CDC *pDC)
{
	CPen *pPenOrg = pDC->SelectObject(&m_penAxis);

	pDC->MoveTo(m_rectGraph.left, m_rectGraph.top);
	pDC->LineTo(m_rectGraph.left, m_rectGraph.bottom);

	pDC->SelectObject(pPenOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawHorizontalAxisLine
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ot̉`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̉`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawHorizontalAxisLine(CDC *pDC)
{
	CPen *pPenOrg = pDC->SelectObject(&m_penAxis);

	pDC->MoveTo(m_rectGraph.left, m_rectGraph.bottom);
	pDC->LineTo(m_rectGraph.right, m_rectGraph.bottom);

	pDC->SelectObject(pPenOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawTactLine
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ڕW^NgƏA̐`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC		*pDC				[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ڕW^NgAA̐jŕ`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawTactLine(CDC *pDC)
{
	CManualEditDocument *pDoc = GetDocument();
	CPen *pPenOrg = pDC->SelectObject(&m_penTact);

	int nGraphSublineNum = m_aZahyoSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];
		SZahyoSubline &cZahyoSubline = m_aZahyoSubline[nSublineIndex];

		int nLeft = cZahyoSubline.nLeft;
		int nRight = cZahyoSubline.nRight;
		if (nSublineIndex == nGraphSublineNum - 1)
			nRight = m_rectGraph.right;

		// ڕW^Ng̐
		int nTactPos = m_rectGraph.bottom - GetScaleHeight(cGraphSubline.fMokugyoTact);
		pDC->SelectObject(&m_penTact);
		pDC->MoveTo(nLeft, nTactPos);
		pDC->LineTo(nRight, nTactPos);

		// ̐
		int nJogenPos = m_rectGraph.bottom - GetScaleHeight(cGraphSubline.fJogen);
		pDC->SelectObject(&m_penTactLimit);
		pDC->MoveTo(nLeft, nJogenPos);
		pDC->LineTo(nRight, nJogenPos);
		pDC->MoveTo(nLeft, nJogenPos - 1);
		pDC->LineTo(nRight, nJogenPos - 1);

		// ̐
		int nKagenPos = m_rectGraph.bottom - GetScaleHeight(cGraphSubline.fKagen);
		pDC->MoveTo(nLeft, nKagenPos);
		pDC->LineTo(nRight, nKagenPos);
		pDC->MoveTo(nLeft, nKagenPos - 1);
		pDC->LineTo(nRight, nKagenPos - 1);
	}

	pDC->SelectObject(pPenOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawVerticalAxisText
//----------------------------------------------------------------------------------------------------
//  2. @\
//		c̕`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			*pDC				[I] foCXReLXg
//		LPCTSTR		pText				[I] \镶
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		c̍̕`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawVerticalAxisText(CDC *pDC, LPCTSTR pText)
{
	CFont *pFontOrg = pDC->SelectObject(&m_fontV);

	// \TCY擾
	CSize sizeText = pDC->GetTextExtent(pText);

	// c̒ɕ\
	pDC->TextOut(m_rectGraph.left - sizeText.cy - 8, m_rectGraph.top + (m_rectGraph.Height() + sizeText.cx) / 2, pText);

	pDC->SelectObject(pFontOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawLegends
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			*pDC				[I] foCXReLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Ot̖}`悷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawLegends(CDC *pDC)
{
	CRect rect;
	int nLeft = m_rectGraph.right + 10;
	int nTop = m_rectGraph.top;
	CPen *pPenOrg = pDC->SelectObject(&m_penGraph);

	// @Ń[v
	int nKishuNum = g_pDataManager->GetKishuNum();
	for (int nKishuId = 0; nKishuId < nKishuNum; nKishuId++) {
		SKishu *pKishu = g_pDataManager->GetKishuData(nKishuId);

		rect.SetRect(nLeft, nTop, nLeft + 70, nTop + 20);
		CBrush *pBrushOrg = pDC->SelectObject(&m_brushGraph[nKishuId]);

		// lp̒ɋ@햼\
		if (pDC->RectVisible(rect)) {
			pDC->Rectangle(rect);
			pDC->DrawText(pKishu->sKishuName, rect, DT_CENTER | DT_VCENTER | DT_TOP | DT_SINGLELINE | DT_NOCLIP | DT_NOPREFIX);
		}
		pDC->SelectObject(&pBrushOrg);

		nTop += 30;
	}

	pDC->SelectObject(pPenOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::DrawTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		vԕ`
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			*pDC			[I] foCXReLXg
//		int			nLeft			[I] \ʒu
//		double		fTime			[I] v
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		vԂƏ[x`悷BڕW^Ng̏𒴂Ăꍇ͐Ԃŕ\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::DrawTime(CDC *pDC, SGraphSubline &cGraphSubline, int nLeft, double fTime)
{
	CString sTime;

	int nTextHeight = m_rectGraph.bottom - GetScaleHeight(max(cGraphSubline.fJogen, fTime));
	CRect rectText(nLeft, 0, nLeft + m_nBarWidth, nTextHeight - 8);
	if (pDC->RectVisible(rectText)) {
		// 𒴂Ăꍇ͐Ԃŕ\
		int color = pDC->SetTextColor(fTime > cGraphSubline.fJogen ? RGB(255, 0, 0) : RGB(0, 0, 0));

		// [x
// Modify ... ( CHANGE )
		CString str1 = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[2].MenuNo, Menu_ManualWindowText[2].ItemNo );
		sTime.Format(str1, fTime / cGraphSubline.fMokugyoTact * 100);
//		sTime.Format("%.1f%%", fTime / cGraphSubline.fMokugyoTact * 100);
// By Y.Itabashi (xxxxx) 2007.01.26
		pDC->DrawText(sTime, rectText, DT_CENTER | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP | DT_NOPREFIX);

		// Ǝ
// Modify ... ( CHANGE )
		CString str2 = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[1].MenuNo, Menu_ManualWindowText[1].ItemNo );
		sTime.Format(str2, fTime);
//		sTime.Format("%.3f", fTime);
// By Y.Itabashi (xxxxx) 2007.01.26
		rectText.bottom -= 16;
		pDC->DrawText(sTime, rectText, DT_CENTER | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP | DT_NOPREFIX);
//		pDC->DrawText("v", rectText, DT_CENTER | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

		pDC->SetTextColor(color);
	}
}

// TuCԋ؂`
void CManualEditView::DrawSublineBoundLine(CDC *pDC)
{
	CPen *pPenOrg = pDC->SelectObject(&m_penSublineBar);

	int nGraphSublineNum = m_aZahyoSubline.GetSize();
	for (int nSublineIndex = 1; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SZahyoSubline &cZahyoSubline = m_aZahyoSubline[nSublineIndex];

		if (cZahyoSubline.nSublineId != -1) {
			pDC->MoveTo(cZahyoSubline.nLeft, 0);
			pDC->LineTo(cZahyoSubline.nLeft, m_rectGraph.bottom);
			pDC->MoveTo(cZahyoSubline.nLeft - 1, 0);
			pDC->LineTo(cZahyoSubline.nLeft - 1, m_rectGraph.bottom);
		} else {
			pDC->SelectObject(&m_penKittingLine);
			pDC->MoveTo(cZahyoSubline.nLeft, 0);
			pDC->LineTo(cZahyoSubline.nLeft, m_rectGraph.bottom);
		}
	}

	pDC->SelectObject(pPenOrg);
}

// LbgTuCԋ؂`
void CManualEditView::DrawKittingSubline(CDC *pDC)
{
	CRect rect;
	CPen *pPenOrg = pDC->SelectObject(&m_penKittingSubline);
	CFont *pFontOrg = pDC->SelectObject(&m_fontGraph);

	int nSize = m_aZahyoKittingSubline.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoKittingSubline &cKittingSubline = m_aZahyoKittingSubline[i];
		int x = cKittingSubline.pointLine.x;
		int y = cKittingSubline.pointLine.y;

		rect.SetRect(x - m_nBarSpacing / 2, y - 14, x + m_nBarWidth + m_nBarSpacing, y + 14);
		if (pDC->RectVisible(rect)) {
			pDC->MoveTo(x - m_nBarSpacing / 2, y - 1);
			pDC->LineTo(x + m_nBarWidth + m_nBarSpacing / 2, y - 1);
			pDC->MoveTo(x - m_nBarSpacing / 2, y);
			pDC->LineTo(x + m_nBarWidth + m_nBarSpacing / 2, y);

			if (!cKittingSubline.sSiblineName1.IsEmpty())
				pDC->TextOut(x + m_nBarWidth + 2, y - 14, cKittingSubline.sSiblineName1);

			if (!cKittingSubline.sSiblineName2.IsEmpty())
				pDC->TextOut(x + m_nBarWidth + 2, y + 3, cKittingSubline.sSiblineName2);
		}
	}

	pDC->SelectObject(pPenOrg);
	pDC->SelectObject(pFontOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::OnToolHitTest
//----------------------------------------------------------------------------------------------------
//  2. @\
//		c[`bv̍W`FbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CPoint		point			[I] }EXJ[\̈ʒu
//		TOOLINFO	*pTI			[I] c[`bv
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		Wz̃CfbNX
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽʒuɎlp`݂ꍇ̓c[`bvɕ\f[^ZbgB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
int CManualEditView::OnToolHitTest(CPoint point, TOOLINFO* pTI) const
{
	SZahyoGraph *pZahyoGraph;
	CRect rect;

	CPoint pointScroll = GetScrollPosition();

	// Wz̒w肳ꂽʒu܂ގlp`
	int nSize = m_aZahyoGraph.GetSize();
	for (int i = 0; i < nSize; i++) {
		pZahyoGraph = &m_aZahyoGraph[i];
		rect = pZahyoGraph->rect - pointScroll;
		if (rect.PtInRect(point))
			break;
	}
	if (i < nSize) {
		pTI->hwnd = m_hWnd;
		pTI->uFlags &= ~TTF_IDISHWND;
		pTI->rect = rect;
		pTI->uId = i;
		pTI->lpszText = LPSTR_TEXTCALLBACK;
		return i;
	}

	return -1;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::OnGetToolTipText
//----------------------------------------------------------------------------------------------------
//  2. @\
//		c[`bv\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		NMHDR		*pNMH			[I] NMHDR|C^
//		LRESULT		*pRes			[I] LRESULT|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		c[`bvɕ\eLXgpӂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::OnGetToolTipText(NMHDR* pNMH, LRESULT* pRes)
{
	TOOLTIPTEXT *pTTT = (TOOLTIPTEXT*)pNMH;

	// c[`bv\nŉs悤ɂ
	_AFX_THREAD_STATE* pThreadState = AfxGetThreadState();
	CToolTipCtrl* pToolTip = pThreadState->m_pToolTip;
	if (pToolTip != NULL)
		pToolTip->SendMessage(TTM_SETMAXTIPWIDTH, 0, 300);

	// c[`bvɕ\镶ݒ
	if ((int)pNMH->idFrom < m_aZahyoGraph.GetSize())
		pTTT->lpszText = (LPTSTR)(LPCTSTR)m_aZahyoGraph[pNMH->idFrom].sText;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::SetTactHeight
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ڕW^Ng̈ʒuݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		BOOL	bAdjust				[I] ڕW^Ngʒu␳tO
//		int		nKishuId			[I] @ID
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ڕW^Ng̕\ʒuݒ肷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CManualEditView::SetScaleFactor(BOOL bAdjust, int nKishuId)
{
	CManualEditDocument *pDoc = GetDocument();

	// ő̖ڕW^Ng擾
	double fMaxTime = 0;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];

		if (cGraphSubline.fMokugyoTact > fMaxTime)
			fMaxTime = cGraphSubline.fMokugyoTact;
	}

	// Ot̃o[ɂ͂ݏoꍇ́AڕW^Ng̈ʒu
	if (bAdjust) {
		double fTime = GetMaxTime(nKishuId);
		if (fTime > fMaxTime)
			fMaxTime = fTime;
	}

	m_fScaleFactor = m_rectGraph.Height() / fMaxTime * 0.9;
}

//*****************************************************************************************************
//  1. ֐
//		CManualEditView::GetMaxTime
//----------------------------------------------------------------------------------------------------
//  2. @\
//		łƎԂ擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nKishuId			[I] @ID
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽ@̒ōłƎԂ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
double CManualEditView::GetMaxTime(int nKishuId)
{
	CManualEditDocument *pDoc = GetDocument();

	double fMaxTime = 0;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];

		if (cGraphSubline.nSublineId != -1) {
			int nSagyoshaNum = cGraphSubline.aGraphSagyosha.GetSize();
			for (int i = 0; i < nSagyoshaNum; i++) {
				SGraphSagyosha &cGraphSagyosha = cGraphSubline.aGraphSagyosha[i];
				if (nKishuId < 0) {
					// dς̏ꍇ
					if (cGraphSagyosha.fTime > fMaxTime)
						fMaxTime = cGraphSagyosha.fTime;

					if (nKishuId == -2) {
						int nKishuNum = cGraphSagyosha.aKishu.GetSize();
						for (int j = 0; j < nKishuNum; j++) {
							SGraphKishu &cGraphKishu = cGraphSagyosha.aKishu[j];
							if (cGraphKishu.fTime > fMaxTime)
								fMaxTime = cGraphKishu.fTime;
						}
					}
				} else {
					// @ʂ̏ꍇ
					SGraphKishu &cGraphKishu = cGraphSagyosha.aKishu[nKishuId];
					if (cGraphKishu.fTime > fMaxTime)
						fMaxTime = cGraphKishu.fTime;
				}
			}
		}
	}

	return fMaxTime;
}

// X\ݒ
void CManualEditView::SetSlimMode()
{
	CManualEditDocument *pDoc = GetDocument();

	if (pDoc->m_bSlimMode) {
		SetSlim(m_nBarWidth);
		SetSlim(m_nLeftSpacing);
		SetSlim(m_nBarSpacing);
	}
}

void CManualEditView::SetSlim(int &nScale)
{
	nScale = nScale * 3 / 5;
}

int CManualEditView::GetTotalSagyoshaNum()
{
	CManualEditDocument *pDoc = GetDocument();

	int nTotalSagyoshaNum = 0;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];
		if (cGraphSubline.nSublineId != -1)
			nTotalSagyoshaNum += cGraphSubline.aGraphSagyosha.GetSize();
	}

	return nTotalSagyoshaNum;
}

int CManualEditView::GetKittingSagyoshaNum()
{
	CManualEditDocument *pDoc = GetDocument();

	return pDoc->m_nKittingIndex != -1 ? pDoc->m_aGraphSubline[pDoc->m_nKittingIndex].aGraphSagyosha.GetSize() : 0;
}

void CManualEditView::DispSublineInfo()
{
	CManualEditDocument *pDoc = GetDocument();

	CString sText1, sText2, sText3;
	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SGraphSubline &cGraphSubline = pDoc->m_aGraphSubline[nSublineIndex];
		SZahyoSubline &cZahyoSubline = m_aZahyoSubline[nSublineIndex];

// Modify ... ( CHANGE )
		CString str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[3].MenuNo, Menu_ManualWindowText[3].ItemNo );
		sText1.Format(str, cGraphSubline.sSublineName);
		str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[4].MenuNo, Menu_ManualWindowText[4].ItemNo );
		sText2.Format(str, cGraphSubline.fMokugyoTact, cGraphSubline.aGraphSagyosha.GetSize());
		str = g_pSystem->m_cMenuDisp.GetMenu( Menu_ManualWindowText[5].MenuNo, Menu_ManualWindowText[5].ItemNo );
		sText3.Format(str, cGraphSubline.fKadoRitsu, g_pDataManager->GetSeisanDaisu(cGraphSubline.nSublineId));
//		sText1.Format("TuCF%s", cGraphSubline.sSublineName);
//		sText2.Format("ڕW^NgF%.2f@/@ƎҁF%dl", cGraphSubline.fMokugyoTact, cGraphSubline.aGraphSagyosha.GetSize());
//		sText3.Format("ғF%.0f%%@/@Y䐔F%d", cGraphSubline.fKadoRitsu, g_pDataManager->GetSeisanDaisu(cGraphSubline.nSublineId));
// By Y.Itabashi (xxxxx) 2007.01.26
		cZahyoSubline.cSublineInfo.SetText(sText1, sText2, sText3);
	}

    m_moveHight = 0;	// 20070214 xxxxx kuwa
	SetSublineInfoPos();
}

void CManualEditView::SetSublineInfoPos()
{
	CManualEditDocument *pDoc = GetDocument();
	CPoint point = GetScrollPosition();

	CRect rectClient;
	GetClientRect(rectClient);
	rectClient.OffsetRect(point.x, 0);

	int nGraphSublineNum = pDoc->m_aGraphSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++) {
		SZahyoSubline &cZahyoSubline = m_aZahyoSubline[nSublineIndex];

		int nLeft = max(rectClient.left, cZahyoSubline.nLeft);
		int nRight = min(rectClient.right, cZahyoSubline.nRight);
		int nWidth = nRight - nLeft;

		CRect rectSublineIndo;
		cZahyoSubline.cSublineInfo.GetClientRect(rectSublineIndo);
		if (nWidth > rectSublineIndo.Width()) {
			cZahyoSubline.cSublineInfo.SetWindowPos(NULL, (nLeft + nRight - rectSublineIndo.Width()) / 2 - point.x, 5, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
			cZahyoSubline.cSublineInfo.ShowWindow(SW_SHOW);
		} else
			cZahyoSubline.cSublineInfo.ShowWindow(SW_HIDE);
	}

	// ԉɃXN[ 20070213 xxxxx kuwa
	if ( m_moveHight == 0 ) {	// cʒuӂɎĂ܂
	   ScrollToPosition( CPoint(point.x, m_rectView.Height() - rectClient.Height()));
	} else {					// cʒu͎w肵Ƃ
	   ScrollToPosition( CPoint(point.x,  point.y));
	}
}

void CManualEditView::HideSublineInfo()
{
	int nGraphSublineNum = m_aZahyoSubline.GetSize();
	for (int nSublineIndex = 0; nSublineIndex < nGraphSublineNum; nSublineIndex++)
		m_aZahyoSubline[nSublineIndex].cSublineInfo.ShowWindow(SW_HIDE);
}

void CManualEditView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	HideSublineInfo();

	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);

	m_moveHight = 1;	// 20070214 xxxxx kuwa
	SetSublineInfoPos();
}

void CManualEditView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	HideSublineInfo();

	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);

	m_moveHight = 1;	// 20070214 xxxxx kuwa
	SetSublineInfoPos();
}

int CManualEditView::GetScaleHeight(double fMinute)
{
	return (int)(fMinute * m_fScaleFactor + 0.5);
}

// w肵Ǝ҂𒆉ɕ\
void CManualEditView::DispCenterSagyosha(int nSublineId, int nSagyoshaId)
{
	int nSize = m_aZahyoSagyosha.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoSagyosha &cZahyoSagyosha = m_aZahyoSagyosha[i];

		if (cZahyoSagyosha.nSublineId == nSublineId && cZahyoSagyosha.nSagyoshaId == nSagyoshaId) {
			CRect rect;
			GetClientRect(rect);
			ScrollToPosition(CPoint(cZahyoSagyosha.rect.CenterPoint().x - rect.Width() / 2, m_rectView.Height() - rect.Height()));
			break;
		}
	}
}

// w肵ʒuǂ̃TuCGAׂ
SZahyoSubline *CManualEditView::GetZahyoSubline(CPoint point)
{
	point += GetScrollPosition();

	int nSize = m_aZahyoSubline.GetSize();
	for (int i = 0; i < nSize; i++) {
		SZahyoSubline &cZahyoSubline  = m_aZahyoSubline[i];
		if (point.x > cZahyoSubline.nLeft && point.x < cZahyoSubline.nRight)
			return &cZahyoSubline;
	}

	return NULL;
}
